kan-extensions
==============

[![Build Status](https://secure.travis-ci.org/ekmett/kan-extensions.png?branch=master)](http://travis-ci.org/ekmett/kan-extensions)

This package provides tools for working with various Kan extensions and Kan lifts in Haskell.

Among the interesting bits included are:

* Right and left Kan extensions (`Ran` and `Lan`)
* Right and left Kan lifts (`Rift` and `Lift`)
* Multiple forms of the Yoneda lemma (`Yoneda`)
* The `Codensity` monad, which can be used to improve the asymptotic complexity of code over free monads (`Codensity`, `Density`)
* A "comonad to monad-transformer transformer" that is a special case of a right Kan lift. (`CoT`, `Co`)

Contact Information
-------------------

Contributions and bug reports are welcome!

Please feel free to contact me through github or on the #haskell IRC channel on irc.freenode.net.

-Edward Kmett
